#include <keyboard_syscalls.h>
#include "types.h"
#include "screen.h"

void mirervb(uint8_t* l, uint8_t n) {
	uint16_t w=SCREEN_WIDTH, i;
	uint8_t h=SCREEN_HEIGHT, j=0, k, nv, nv2;
	uint32_t *lc=(uint32_t*)sys_malloc(n*sizeof(uint32_t)), *lb=(uint32_t*)sys_malloc(n*sizeof(uint32_t)), *lv=(uint32_t*)sys_malloc(((1<<n)-1)*sizeof(uint32_t));
	double *lf=(double*)sys_malloc(n*sizeof(double));
	for(i=0;i<n;i++) {
		lb[i]=1<<j;
		j=j+l[i];
		lf[i]=((1<<l[i])-1)/(double)(w-1);
	}
	for(i=0;i<w;i++) {
		for(j=0;j<n;j++)
			lc[j]=lb[j]*(uint32_t)(i*lf[j]);
		nv=0;
		for(j=0;j<n;j++) {
			nv2=nv;
			lv[nv++]=lc[j];
			for(k=0;k<nv2;k++)
				lv[nv++]=lv[k]+lc[j];
		}
		for(j=0;j<nv;j++)
			draw_vline(i,j*h/nv,(j+1)*h/nv-1,lv[j]);
	}
	sys_free(lf);
	sys_free(lv);
	sys_free(lb);
	sys_free(lc);
}

int main() {
	int key=0;
	uint8_t l[3];
	uint8_t n=3;
	l[0]=5;
	l[1]=6;
	l[2]=5;
	initScreen();
	mirervb(l,n);
    while (!key)
        GetKey(&key);
	stopScreen();
	return 0;
}